/* TAGS: ext c++ todo */
/* VERIFY_OPTS: -o nofail:malloc */
/* CC_OPTS: -std=c++17 -I$SRC_ROOT/bricks */

#include <pthread.h>
#include <thread>
#include <cassert>
#include <brick-hashset>

struct adaptor : brq::hash_adaptor< int >
{
    int hash( int ) const { return 0; }
};

brq::concurrent_hash_set< int, brq::impl::grow< 1, 2, 4 >, 4 > set, set1( set ), set2( set );
adaptor adapt;

void *thread1( void * )
{
    set1.insert( 3, adapt );
    return nullptr;
}

void *thread2( void * )
{
    set2.insert( 3, adapt );
    return nullptr;
}

int main()
{
    set.insert( 1, adapt );
    set.insert( 2, adapt );

    pthread_t tid1, tid2;
    pthread_create( &tid1, nullptr, thread1, nullptr );
    pthread_create( &tid2, nullptr, thread2, nullptr );

    set.erase( 1, adapt );
    set.erase( 2, adapt );

    pthread_join( tid1, nullptr );
    pthread_join( tid2, nullptr );

    int count = 0;

    for ( int i = 0; i < set.capacity(); ++i )
        if ( !set.cell_at( i ).empty() && !set.cell_at( i ).tombstone() )
        {
            ASSERT_EQ( set.cell_at( i ).fetch(), 3 );
            count ++;
        }
    ASSERT_EQ( count, 1 );
}
