/* TAGS: ext c++ todo */
/* VERIFY_OPTS: -o nofail:malloc */
/* CC_OPTS: -std=c++17 -I$SRC_ROOT/bricks */

#include <pthread.h>
#include <thread>
#include <cassert>
#include <brick-hashset>

brq::concurrent_hash_set< int, brq::impl::grow< 2, 4 >, 4 > set1, set2( set1 );

void *thread( void * )
{
    bool erased = set2.erase( 1 );
    ASSERT( erased );
    return nullptr;
}

int main()
{
    set1.insert( 1 );
    pthread_t tid;
    pthread_create( &tid, nullptr, thread, nullptr );

    auto [ v, inserted ] = set1.insert( 1 );
    pthread_join( tid, nullptr );

    if ( inserted )
        ASSERT( set1.count( 1 ) );
    else
        ASSERT( !set1.count( 1 ) );

    int taken = 0;

    for ( int i = 0; i < set1.capacity(); ++i )
        if ( !set1.cell_at( i ).empty() )
            ++ taken;

    ASSERT_LEQ( taken, 1 );
    ASSERT_EQ( set1.capacity(), 2 );
}
