/* TAGS: ext c++ todo */
/* VERIFY_OPTS: -o nofail:malloc */
/* CC_OPTS: -std=c++17 -I$SRC_ROOT/bricks */

#include <pthread.h>
#include <thread>
#include <cassert>
#include <brick-hashset>

brq::concurrent_hash_set< int, brq::impl::grow< 1, 2, 4 >, 4 > set1, set2( set1 );

void *thread( void * )
{
    set2.insert( 3 );
    set2.insert( 4 );
    return nullptr;
}

int main()
{
    set1.insert( 1 );
    ASSERT_EQ( set1.capacity(), 1 );

    pthread_t tid;
    pthread_create( &tid, nullptr, thread, nullptr );

    set1.insert( 2 );
    ASSERT( set1.count( 2 ) );
    set1.erase( 2 );
    ASSERT( !set1.count( 2 ) );

    pthread_join( tid, nullptr );
    ASSERT_EQ( set1.capacity(), 4 );
}
