/* TAGS: error min c */
#include <dios.h>
#include <stdlib.h>
#include <assert.h>

volatile int start;

void *getTls( __dios_task id )
{
    return &id->__data;
}

void routine( void * x )
{
    __dios_trace_t( "routine just started" );
    while( !start );
    __dios_trace_t( "routine got past !start" );
    int *tls = getTls( __dios_this_task() );
    *tls = 42;
    __dios_trace_t( "routine wrote 42" );
    while ( 1 );
}


int main()
{
    __dios_trace_t( "main started" );
    int *tls = getTls( __dios_start_task( routine, NULL, 2 * sizeof( int ) ) );
    *tls = 0;
    __dios_trace_t( "about to set start = 1" );
    start = 1;
    __dios_trace_t( "waiting for $tls == 42" );
    while( *tls != 42 );
    __dios_trace_t( "done" );
    assert( 0 ); /* ERROR */
}
